/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : mardi 01 aot 2006 - 21h42
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : ThreadFreeGoInformations.h
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#ifndef THREADFREEGOINFORMATIONS_H
#define THREADFREEGOINFORMATIONS_H

#include <QThread>
#include <QPointer>
#include <QDateTime>

class QSettings;

class ThreadFreeGoInformations : public QThread
{
	Q_OBJECT

public:
	static ThreadFreeGoInformations* self();
	void run();
	bool publigoShown() const;

public slots:
	void setPubligoShow();

protected:
	static QPointer<ThreadFreeGoInformations> mSelf;
	bool mPubligoShown;
	
	ThreadFreeGoInformations();

protected slots:
	void requestInformationsFile();
	void readFreeGoInformations( QSettings*, bool );
	void requestMessagesFile();
	void readLogin( QSettings*, bool error );
	void readMessages( const QByteArray& buffer, bool error );

signals:
	void requestInformations();
	void requestMessages();
	void alert( const QString& );
	void programUpdate( int, const QDateTime&, const QString& );  // validity, version, msg
	void programUpdating( int, const QDateTime&, const QString& );
	void freeboxUpdate( int, const QDateTime&, const QString& );
	void freeActualityUpdate( int, const QDateTime&, const QString& );
	void teamMessageUpdate( int, const QDateTime&, const QString& );
	void freegoAnnonce( int, const QDateTime&, const QString&, const QString& );
	void newMessages( int count );
};

#endif // THREADFREEGOINFORMATIONS_H
