/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : mardi 25 juillet 2006 - 19h40
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox@gmail.com )
* FILENAME     : main.cpp
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#include <QApplication>
#include <QMessageBox>
#include <QTime>

#include "main.h"
#include "UINotify.h"
#include "Threads.h"
#include "Options.h"

int main( int argc, char ** argv )
{
	QApplication app( argc, argv );
	qsrand( QTime( 0, 0, 0 ).secsTo( QTime::currentTime() ) );
	app.setOrganizationName( ORGANIZATION );
	app.setOrganizationDomain( QString( "www.%1.com" ).arg( ORGANIZATION ).toLower() );
	app.setApplicationName( PROGRAM_NAME );
	app.setQuitOnLastWindowClosed( false );
#if defined Q_OS_UNIX && !defined Q_OS_MAC
	app.setStyle( "plastique" ); // kde4 oxygen style is bugguy
#endif
	// init error window
	//QErrorMessage::qtHandler();
	// first show counter
	if ( !Options::current()->value( "/FreeGo/Options/FirstLaunch", false ).toBool() )
	{
		REQUESTER->requestUrl( QUrl( "http://www.free-go.net/first.php" ) );
		Options::current()->setValue( "/FreeGo/Options/FirstLaunch", true );
	}
	// show main window
	UIMAIN->setWindowTitle( PROGRAM_TITLE );
	switch ( Options::current()->value( "/FreeGo/Options/AutoStartMode", 0 ).toInt() )
	{
		case 1: // reduit
			UIMAIN->setSmall( true );
			UIMAIN->show();
			break;
		case 2: // systray
			break;
		case 0: // classique
		default:
			UIMAIN->show();
			break;
	}
	// init notify object
	Notify::self();
	// init and start threads
	Threads::init();
	// wait app end
	int i = app.exec();
	// stop and clean threads
	Threads::clean();
	return i;
}
