/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : lundi 04 septembre 2006 - 19h17
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : UIConfigure.h
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#ifndef UICONFIGURE_H
#define UICONFIGURE_H

#include "ui_UIConfigure.h"

#include <QPointer>
#include <QButtonGroup>

class UIConfigure : public fgDialog, public Ui::UIConfigure
{
	Q_OBJECT

public:
	static UIConfigure* self( QWidget* = 0 );
	~UIConfigure();

private:
	UIConfigure( QWidget* = 0 );
	static QPointer<UIConfigure> mSelf;
	QButtonGroup mFreeBoxGroup;

private slots:
	void updateConnexionButton();
	void fgMenu_clicked( int i );
	void loadFreeAccounts();
	void saveFreeAccounts();
	void loadSettings();
	bool saveSettings();
	void accept();
	void on_lwFreeAccounts_itemActivated( QListWidgetItem* );
	void on_fgAddUser_clicked();
	void on_fgRemoveUser_clicked();
	void on_fgConnexion_clicked();
};

#endif // UICONFIGURE_H
