/********************************************************************************************************
	* PROGRAM      : FreeGo4
	* DATE - TIME  : mardi 25 juillet 2006 - 22h51
	* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox gmail.com )
	* FILENAME     : UIInvoice.h
	* LICENSE      : GPL
	* COMMENTARY   : 
	********************************************************************************************************/
#ifndef UIINVOICE_H
#define UIINVOICE_H
//
#include "ui_UIInvoice.h"
//
#include <QPointer>
//
class QSettings;
//
class UIInvoice : public fgDialog, public Ui::UIInvoice
{
	Q_OBJECT
	//
public:
	enum DialogMode { dmInvoice = 0, dmTelephony, dmTelevision };
	static UIInvoice* self( QWidget* = 0 );
	//
private:
	UIInvoice( QWidget* = 0 );
	static QPointer<UIInvoice> mSelf;
	QString mUrlInvoices, mUrlTelephony, mUrlTelevision;
	DialogMode mMode;
	QHash<int, int> mRequests;
	//
public slots:
	void changeMode( const DialogMode& );
	void readLogin( QSettings*, bool );
	void readInvoices( const QByteArray& buffer, bool error );
	void readTelephony( const QByteArray& buffer, bool error );
	void readTelevision( const QByteArray& buffer, bool error );
	void on_twInvoices_itemDoubleClicked( QTreeWidgetItem* item, int column );
	void on_fgShowDetails_clicked();
	void saveInvoices();
	void customRequestFinished( int id, bool error, QIODevice* device );
	//
};
//
#endif // UIINVOICE_H
