/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : jeudi 27 juillet 2006 - 19h52
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : UILineFeature.cpp
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#include "UILineFeature.h"
#include "main.h"
#include "misc.h"
//
#include <QShowEvent>
#include <QSettings>
#include <QHeaderView>
//
QPointer<UILineFeature> UILineFeature::mSelf = 0L;
//
UILineFeature* UILineFeature::self( QWidget* p )
{
	if ( !mSelf )
		mSelf = new UILineFeature( p );
	return mSelf;
}
//
UILineFeature::UILineFeature( QWidget* p )
	: fgDialog( p )
{
	setupUi( this );
	fixMacWidgets();
	// change mode
	switch ( misc::identify().Connexion )
	{
		case FreeBoxTotal:
			changeMode( dmFreeBox );
			break;
		case FreeBoxNDI:
		case FreeBoxIP:
		case FreeBoxIPTotal:
			changeMode( dmSagem );
			break;
	}
	REQUESTER->login( this, "readLogin" );
}
//
void UILineFeature::showEvent( QShowEvent* e )
{
	fgDialog::showEvent( e );
	//
	twLineFeature->setItemHidden( twLineFeature->headerItem(), true );
	twLineFeature->header()->resizeSection( 0, 120 );
	twLineFeature->header()->resizeSection( 1, ( twLineFeature->width() -120 ) / 2 );
	twLineFeature->setVerticalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
	twLineFeature->setHorizontalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
}
//
void UILineFeature::changeMode( const DialogMode& m )
{
	switch ( m )
	{
		case dmSagem:
			setBackgroundPixmap( QPixmap( ":/caracteristiques/Pictures/caracteristiques/caracteristiques01.png" ) );
			break;
		case dmFreeBox:
			setBackgroundPixmap( QPixmap( ":/caracteristiques/Pictures/caracteristiques/caracteristiques02.png" ) );
			break;
	}
	fgClose->move( width() -( fgClose->width() +5 ), 4 );
	setWidgetTransparent( twLineFeature, backgroundPixmap() );
}
//
void UILineFeature::readLogin( QSettings*, bool b )
{
	if ( b )
	{
		UIMAIN->alert( "Impossible de vous identifiez sur free, annulation" );
		deleteLater();
		return;
	}
	REQUESTER->requestUrl( this, "readLineFeature", REQUESTER->freeBaseUrl().append( "suivi/suivi_techgrrr.pl" ), "GET", pHttpRequest::rtByteArray );
}
//
void UILineFeature::readLineFeature( const QByteArray& buffer, bool error )
{
	if ( error )
	{
		UIMAIN->alert( "Impossible de telecharger le fichier suivi_techgrrr.pl" );
		return;
	}
	
	// parse
	QString ba = QString::fromLatin1( buffer );
	
	QString key = "<div  id=\"content\" class=\"abonnement\">";
	int pos = ba.indexOf( key );
	ba = ba.mid( pos );
	
	key = "<div class=\"clearer\">";
	pos = ba.indexOf( key );
	ba = ba.left( pos ).trimmed();
	
	QRegExp rx( "<span class=\"red\">((.*))</span>" );
	rx.setMinimal( true );
	pos = 0;
	int count = 0;
	while ( ( pos = rx.indexIn( ba, pos ) ) != -1 )
	{
		// increment pos
		pos += rx.matchedLength();
		// get span tag
		QString s = misc::toPlainText( rx.cap( 1 ).simplified() );
		// update gui
		switch ( count )
		{
			case 0: // FT
				lFTLine2->setText( s );
				break;
			case 1: // Offre
				lOffer2->setText( s );
				break;
			case 2: // NRA
				lNRA2->setText( s );
				break;
			case 3: // Longueur
				lLonger2->setText( s );
				break;
			case 4: // Affaiblissement
				lAffaiblissement2->setText( s );
				break;
		}
		count++;
	}
	
	rx = QRegExp( "Freebox est le <b>((.*))</b>" );
	rx.setMinimal( true );
	if ( ( pos = rx.indexIn( ba.simplified() ) ) != -1 )
		lFreeBoxLine2->setText( rx.cap( 1 ) );
	
	rx = QRegExp( "<table.*>.*</table>" );
	rx.setMinimal( true );
	pos = 0;
	count = 0;
	while ( ( pos = rx.indexIn( ba, pos ) ) != -1 )
	{
		// increment pos
		pos += rx.matchedLength();
		// get table tag
		QString table = rx.cap( 0 ).simplified();
		// parse table
		QList<QStringList> mTable = misc::parseHtmlTable( table, true );
		// update gui
		switch ( count )
		{
			case 0:
				if ( mTable.value( 0 ).value( 0 ) == "Votre adresse IP/masque" )
					lIP2->setText( mTable.value( 0 ).value( 1 ) );
				if ( mTable.value( 2 ).value( 0 ) == "Personalisation DNS" )
					lDNS2->setText( mTable.value( 2 ).value( 1 ).left( mTable.value( 2 ).value( 1 ).indexOf( "->" ) ).trimmed() );
				break;
			case 1:
				if ( mTable.value( 0 ).value( 0 ).contains( "DSLAM", Qt::CaseInsensitive ) )
					lDSLAM2->setText( mTable.value( 0 ).value( 0 ).remove( "DSLAM", Qt::CaseSensitive ).trimmed() );
				if ( mTable.count() > 0 )
				{
					mTable.removeFirst();
					foreach ( const QStringList& row, mTable )
					{
						/*
						if ( row.count() == 4 )
							continue;
						*/
						QTreeWidgetItem* it = new QTreeWidgetItem( twLineFeature );
						it->setText( 0, row.value( 0 ) );
						it->setToolTip( 0, row.value( 0 ).trimmed() );
						it->setTextAlignment( 1, Qt::AlignRight | Qt::AlignVCenter );
						it->setTextAlignment( 2, Qt::AlignRight | Qt::AlignVCenter );
						if ( row.count() == 4 )
						{
							it->setText( 2, row.value( 1 ) );
							QTreeWidgetItem* it = new QTreeWidgetItem( twLineFeature );
							it->setText( 0, row.value( 2 ) );
							it->setToolTip( 0, row.value( 0 ).trimmed() );
							it->setText( 2, row.value( 3 ) );
							it->setTextAlignment( 1, Qt::AlignRight | Qt::AlignVCenter );
							it->setTextAlignment( 2, Qt::AlignRight | Qt::AlignVCenter );
						}
						else if ( row.count() == 3 )
						{
							it->setText( 1, row.value( 1 ) );
							it->setText( 2, row.value( 2 ) );
						}
						else
						{
							it->setText( 2, row.value( 1 ) );
						}
					}
				}
				break;
		}
		count++;
	}

	//misc::debugInTextEdit( ba )->show();
	/*
		int size = s->beginReadArray( "INFORMATIONS" );
		for ( int i = 0; i < size; ++i )
		{
			s->setArrayIndex( i );
			if ( i == 0 )
				lInformations->setText( s->value( "MESSAGE" ).toString() );
		}
		s->endArray();
	}
	*/
}
