/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : jeudi 24 aot 2006 - 22h15
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : UIPhone.cpp
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#include "UIPhone.h"
#include "main.h"
#include "misc.h"

#include <QShowEvent>
#include <QHeaderView>
#include <QHBoxLayout>

QPointer<UIPhone> UIPhone::mSelf = 0L;

pAction::pAction( QWidget* p )
	: QWidget( p )
{
	fgDialog::fixMacWidgets( this );
	QHBoxLayout* l = new QHBoxLayout( this );
	l->setMargin( 0 );
	l->setSpacing( 0 );
	//
	mPlay = new fgLabel;
	mPlay->setCursor( Qt::PointingHandCursor );
	mPlay->setButtonNormalPixmap( QPixmap( ":/principale/Pictures/principale/btn-fleche01.png" ) );
	l->addWidget( mPlay );
	//
	mDelete = new fgLabel;
	mDelete->setCursor( Qt::PointingHandCursor );
	mDelete->setButtonNormalPixmap( QPixmap( ":/telephonie/Pictures/telephonie/off.png" ) );
	l->addWidget( mDelete );
}

UIPhone* UIPhone::self( QWidget* p )
{
	if ( !mSelf )
		mSelf = new UIPhone( p );
	return mSelf;
}

UIPhone::UIPhone( QWidget* p )
	: fgDialog( p ), mInit( false )
{
	setupUi( this );
	fixMacWidgets();
	pServices->setEnabled( false );
	pMessagerie->setEnabled( false );
	pfgResultat->setVisible( false );
	REQUESTER->login( this, "readLogin" );
	swRight->setCurrentIndex( 0 );
	on_swRight_currentChanged( 0 );
}

void UIPhone::showEvent( QShowEvent* e )
{
	fgDialog::showEvent( e );
	//
	if ( !mInit )
	{
		mInit = true;
		twMessages->setItemHidden( twMessages->headerItem(), true );
		twMessages->setColumnWidth( 0, 80 );
		twMessages->setColumnWidth( 1, 90 );
		twMessages->setColumnWidth( 2, 120 );
		twMessages->setColumnWidth( 3, 80 );
		twMessages->setColumnWidth( 4, 80 );
	}
}

void UIPhone::on_swRight_currentChanged( int i )
{
	fgServices->setPixmap( fgServices->buttonNormalPixmap() );
	fgMessagerie->setPixmap( fgMessagerie->buttonNormalPixmap() );
	fgAnnuaire->setPixmap( fgAnnuaire->buttonNormalPixmap() );
	switch ( i )
	{
	case 0:
		fgServices->setPixmap( fgServices->buttonPushedPixmap() );
		//
		setWidgetTransparent( leCode, pfgServices->buttonNormalPixmap() );
		setWidgetTransparent( leNumeroNonReponse, pfgServices->buttonNormalPixmap() );
		setWidgetTransparent( leDelaiNonReponse, pfgServices->buttonNormalPixmap() );
		setWidgetTransparent( leNumeroOccupation, pfgServices->buttonNormalPixmap() );
		setWidgetTransparent( leNumeroInconditionnel, pfgServices->buttonNormalPixmap() );
		setWidgetTransparent( leDelaiRenvoi, pfgServices->buttonNormalPixmap() );
		//
		REQUESTER->requestUrl( this, "readService", REQUESTER->freeBaseUrl().append( "admin/tel/adminservice.pl" ), "GET", pHttpRequest::rtByteArray );
		pServices->setEnabled( false );
		break;
	case 1:
		fgMessagerie->setPixmap( fgMessagerie->buttonPushedPixmap() );
		//
		setWidgetTransparent( twMessages, pfgMessagerie->buttonNormalPixmap() );
		setWidgetTransparent( leNotification1, pfgMessagerie->buttonNormalPixmap() );
		setWidgetTransparent( leNotification2, pfgMessagerie->buttonNormalPixmap() );
		setWidgetTransparent( leNotification3, pfgMessagerie->buttonNormalPixmap() );
		setWidgetTransparent( leNotification4, pfgMessagerie->buttonNormalPixmap() );
		//
		REQUESTER->requestUrl( this, "readNotification", REQUESTER->freeBaseUrl().append( "admin/tel/notification_tel.pl" ), "GET", pHttpRequest::rtByteArray );
		pMessagerie->setEnabled( false );
		break;
	case 2:
		fgAnnuaire->setPixmap( fgAnnuaire->buttonPushedPixmap() );
		//
		setWidgetTransparent( leNom, pfgAnnuaire->buttonNormalPixmap() );
		setWidgetTransparent( lePrenom, pfgAnnuaire->buttonNormalPixmap() );
		setWidgetTransparent( leVille, pfgAnnuaire->buttonNormalPixmap() );
		setWidgetTransparent( leCP, pfgAnnuaire->buttonNormalPixmap() );
		setWidgetTransparent( leDept, pfgAnnuaire->buttonNormalPixmap() );
		setWidgetTransparent( leNumFreebox, pfgAnnuaire->buttonNormalPixmap() );
		setWidgetTransparent( teResultat, pfgResultat->buttonNormalPixmap() );
		//
		break;
	}
}

void UIPhone::readLogin( QSettings*, bool error )
{
	if ( error )
	{
		UIMAIN->alert( "Impossible de vous identifiez sur free, annulation" );
		deleteLater();
		return;
	}
}

void UIPhone::readService( const QByteArray& buffer, bool error )
{
	if ( error )
	{
		UIMAIN->alert( QString( "An error occurs getting file: %1" ).arg( REQUESTER->freeBaseUrl().append( "admin/tel/adminservice.pl" ) ) );
		//on_swRight_currentChanged( 0 );
		return;
	}
	
	// parse
	QString ba = QString::fromLatin1( buffer );
	
	QString key = "<form";
	int pos = ba.indexOf( key );
	ba = ba.mid( pos );
	
	key = "</form>";
	pos = ba.indexOf( key );
	ba = ba.left( pos +key.length() ).simplified();
	
	// fill cbRenvoi combobox
	QString select = ba;
	key = "<select name=\"mevo_mode\">";
	pos = select.indexOf( key );
	select = select.mid( pos );
	
	key = "</select>";
	pos = select.indexOf( key );
	select = select.left( pos +key.length() ).simplified();
	
	QRegExp rx( "<option\\s?(selected)?\\s?value=\"(\\d)\">((.*))</option>" );
	rx.setMinimal( true );
	pos = 0;
	cbRenvoi->clear();
	while ( ( pos = rx.indexIn( select, pos ) ) != -1 )
	{
		// increment pos
		pos += rx.matchedLength();
		// add entry
		cbRenvoi->addItem( rx.cap( 3 ), rx.cap( 2 ) );
		if ( rx.cap( 1 ).simplified() == "selected" )
			cbRenvoi->setCurrentIndex( cbRenvoi->count() -1 );
	}
	
	// parse inputs
	rx = QRegExp( "<input.*/>" );
	rx.setMinimal( true );
	pos = 0;
	while ( ( pos = rx.indexIn( ba, pos ) ) != -1 )
	{
		// increment pos
		pos += rx.matchedLength();
		// get input tag
		const QString tag = rx.cap( 0 ).simplified();
		const QHash<QString, QString> values = misc::parseHTMLTag( tag );
		const QString name = values.value( "name" );
		const bool isChecked = values.value( "type" ) == "checkbox" && tag.contains( "checked", Qt::CaseInsensitive );
		const QString value = values.value( "value" );
		//checked
		if ( name == "derange" )
			fgRestrictionSortant->setToggled( isChecked );
		else if ( name == "appsort" )
			leCode->setText( value );
		else if ( name == "transrep" )
			fgNonReponse->setToggled( isChecked );
		else if ( name == "nonrep" )
			leNumeroNonReponse->setText( value );
		else if ( name == "delai" )
			leDelaiNonReponse->setText( value );
		else if ( name == "transoccup" )
			fgOccupation->setToggled( isChecked );
		else if ( name == "occup" )
			leNumeroOccupation->setText( value );
		else if ( name == "transinc" )
			fgInconditionnel->setToggled( isChecked );
		else if ( name == "incon" )
			leNumeroInconditionnel->setText( value );
		else if ( name == "mevo_mode" ) // a revoir
			cbRenvoi->setCurrentIndex( cbRenvoi->findText( value ) );
		else if ( name == "mevo_delai" )
			leDelaiRenvoi->setText( value );
		else if ( name == "renvoi" )
			fgProtectionRenvois->setToggled( isChecked );
		else if ( name == "anonymes" )
			fgRejetAnonyme->setToggled( isChecked );
		else if ( name == "absent" )
			fgAbsent->setToggled( isChecked );
		else if ( name == "instance" )
			fgInstance->setToggled( isChecked );
		else if ( name == "identite" )
			fgRestrictionIdentite->setToggled( isChecked );
	}
	
	pServices->setEnabled( true );
}

void UIPhone::on_fgServicesEnregistrer_clicked()
{
	QString mPost = QString( "admin/tel/adminservice_valid.pl?absent=%1&derange=%2&appsort=%3&"
		"identite=%4&renvoi=%5&anonymes=%6&transoccup=%7&occup=%8&instance=%9&"
		"transinc=%10&incon=%11&transrep=%12&nonrep=%13&delai=%14&mevo_mode=%15&"
		"mevo_delai=%16" )
		.arg( fgAbsent->toggled() ? "absent" : "" )
		.arg( fgRestrictionSortant->toggled() ? "derange" : "" )
		.arg( leCode->text() )
		.arg( fgRestrictionIdentite->toggled() ? "identite" : "" )
		.arg( fgProtectionRenvois->toggled() ? "renvoi" : "" )
		.arg( fgRejetAnonyme->toggled() ? "anonymes" : "" )
		.arg( fgOccupation->toggled() ? "transoccup" : "" )
		.arg( leNumeroOccupation->text() )
		.arg( fgInstance->toggled() ? "instance" : "" )
		.arg( fgInconditionnel->toggled() ? "transinc" : "" )
		.arg( leNumeroInconditionnel->text() )
		.arg( fgNonReponse->toggled() ? "transrep" : "" )
		.arg( leNumeroNonReponse->text() )
		.arg( leDelaiNonReponse->text() )
		.arg( cbRenvoi->currentIndex() )
		.arg( leDelaiRenvoi->text() );
	mPost.prepend( REQUESTER->freeBaseUrl() );
	// post data
	REQUESTER->requestUrl( mPost );
	// reload data
	on_swRight_currentChanged( swRight->currentIndex() );
}

void UIPhone::readNotification( const QByteArray& buffer, bool error )
{
	if ( error )
	{
		UIMAIN->alert( QString( "An error occurs getting file: %1" ).arg( REQUESTER->freeBaseUrl().append( "freego/tel/notification_tel.pl" ) ) );
		return;
	}
	
	// clear
	twMessages->clear();
	
	// header
	// create header
	QTreeWidgetItem* headerIt = new QTreeWidgetItem( twMessages );
	headerIt->setFlags( Qt::ItemIsEnabled );
	headerIt->setText( 0, "Type" );
	headerIt->setText( 1, "Provenance" );
	headerIt->setText( 2, QString::fromUtf8( "Réception" ) );
	headerIt->setText( 3, QString::fromUtf8( "Durée" ) );
	headerIt->setText( 4, "Action" );
	// set header font
	for ( int n = 0; n < 5; n++ )
		headerIt->setTextAlignment( n, Qt::AlignLeft );
	
	// parse
	QString ba = QString::fromLatin1( buffer );
	
	QString key = "<div  id=\"content\" class=\"telephone\">";
	int pos = ba.indexOf( key );
	ba = ba.mid( pos );
	
	key = "<div class=\"clearer\">";
	pos = ba.indexOf( key );
	ba = ba.left( pos ).simplified();
	
	// parse messages
	QRegExp rx( "<table.*>.*</table>" );
	rx.setMinimal( true );
	if ( rx.indexIn( ba ) != -1 )
	{
		// get table tag
		QString table = rx.cap( 0 ).simplified();
		if ( table.contains( "Pas de nouveau message", Qt::CaseInsensitive ) )
		{
			QTreeWidgetItem* it = twMessages->topLevelItem( 0 );
			it->setFirstColumnSpanned( true );
			it->setTextAlignment( 0, Qt::AlignHCenter );
			it->setText( 0, "Pas de nouveau message" );
		}
		else
		{
			// parse table
			QList<QStringList> mTable = misc::parseHtmlTable( table, false );
			// create items
			foreach ( const QStringList& row, mTable )
			{
				QTreeWidgetItem* it = new QTreeWidgetItem( twMessages );
				it->setText( 0, row.value( 0 ).replace( "Nouveau message", "Nouveau" ).replace( QString::fromUtf8( "Message déjà écouté" ), QString::fromUtf8( "Archivé" ) ) );
				it->setText( 1, row.value( 1 ) );
				it->setText( 2, row.value( 2 ).remove( 5, 3 ) );
				it->setText( 3, row.value( 3 ).replace( "seconde(s)", "s" ) );
				const QStringList links = row.value( 4 ).split( " / " );
				const QString url = REQUESTER->freeBaseUrl().append( QString( "admin/tel/%1" ) );
				pAction* action = new pAction;
				action->mPlay->setToolTip( QString( url ).arg( misc::parseHTMLTag( links.value( 0 ) ).value( "href" ) ) );
				action->mDelete->setToolTip( QString( url ).arg( misc::parseHTMLTag( links.value( 1 ) ).value( "href" ) ) );
				twMessages->setItemWidget( it, 4, action );
				// connections
				connect( action->mPlay, SIGNAL( clicked() ), this, SLOT( playClicked() ) );
				connect( action->mDelete, SIGNAL( clicked() ), this, SLOT( deleteClicked() ) );
			}
		}
	}
	
	// parse selects
	rx = QRegExp( "<select name=\"(\\w+)\">.*</select>" );
	rx.setMinimal( true );
	pos = 0;
	while ( ( pos = rx.indexIn( ba, pos ) ) != -1 )
	{
		// increment pos
		pos += rx.matchedLength();
		// get select
		QString select = rx.cap( 0 ).simplified();
		QString name = rx.cap( 1 ).simplified();
		// get combobox
		QComboBox* cb = 0;
		if ( name == "type1" )
			cb = cbNotification1;
		else if ( name == "type2" )
			cb = cbNotification2;
		else if ( name == "type3" )
			cb = cbNotification3;
		else if ( name == "type4" )
			cb = cbNotification4;
		// clear combobox
		cb->clear();
		// parse select
		QRegExp rxOption( "<option value=\"(\\d)\"\\s*(selected)?\\s*>((.*))</option>" );
		rxOption.setMinimal( true );
		int posOption = 0;
		while ( ( posOption = rxOption.indexIn( select, posOption ) ) != -1 )
		{
			// increment pos
			posOption += rxOption.matchedLength();
			// add entry
			cb->addItem( misc::toPlainText( rxOption.cap( 3 ) ), rxOption.cap( 1 ) );
			if ( rxOption.cap( 2 ).simplified() == "selected" )
				cb->setCurrentIndex( cb->count() -1 );
		}
	}

	// parse inputs
	rx = QRegExp( "<input.*/>" );
	rx.setMinimal( true );
	pos = 0;
	while ( ( pos = rx.indexIn( ba, pos ) ) != -1 )
	{
		// increment pos
		pos += rx.matchedLength();
		// get input tag
		const QString tag = rx.cap( 0 ).simplified();
		const QHash<QString, QString> values = misc::parseHTMLTag( tag );
		const QString name = values.value( "name" );
		const QString value = values.value( "value" );
		//checked
		if ( name == "email1" )
			leNotification1->setText( value );
		else if ( name == "email2" )
			leNotification2->setText( value );
		else if ( name == "email3" )
			leNotification3->setText( value );
		else if ( name == "email4" )
			leNotification4->setText( value );
	}
	
	pMessagerie->setEnabled( true );
}

void UIPhone::playClicked()
{
	fgLabel* label = qobject_cast<fgLabel*>( sender() );
	if ( label )
		misc::openUrl( label->toolTip() );
}

void UIPhone::deleteClicked()
{
	fgLabel* label = qobject_cast<fgLabel*>( sender() );
	if ( label )
	{
		REQUESTER->requestUrl( label->toolTip() );
		on_swRight_currentChanged( swRight->currentIndex() );
	}
}

void UIPhone::on_fgMessagerieEnregistrer_clicked()
{
	QString mPost = QString( "admin/tel/notification_tel_valid.pl?type1=%1&type2=%2&"
		"type3=%3&type4=%4&email1=%5&email2=%6&email3=%7&email4=%8&notel=0&submit=Valider" )
		.arg( cbNotification1->currentIndex() )
		.arg( cbNotification2->currentIndex() )
		.arg( cbNotification3->currentIndex() )
		.arg( cbNotification4->currentIndex() )
		.arg( leNotification1->text() )
		.arg( leNotification2->text() )
		.arg( leNotification3->text() )
		.arg( leNotification4->text() );
	mPost.prepend( REQUESTER->freeBaseUrl() );
	// post data
	REQUESTER->requestUrl( mPost );
	// reload data
	on_swRight_currentChanged( swRight->currentIndex() );
}

void UIPhone::on_fgAnnuaireRechercher_clicked()
{
	if ( leNumFreebox->text().count() == 10 )
	{
		QString mPost = QString( "annu/inverse.php5?tel=%1" ).arg( leNumFreebox->text() );
		mPost.prepend( REQUESTER->freeGoBaseUrl() );
		REQUESTER->requestUrl( this, "readAnnuaire", mPost );
		pAnnuaire->setEnabled( false );
	}
	else
	{
		if ( !leNom->text().isEmpty() &&
			( !leDept->text().isEmpty() || !leCP->text().isEmpty() || !leVille->text().isEmpty() ) )
		{
			QString mPost = QString( "annu/annuaire.php5?lname=%1&fname=%2&dep=%3&cp=%4&town=%5" )
				.arg( leNom->text() )
				.arg( lePrenom->text() )
				.arg( leDept->text() )
				.arg( leCP->text() )
				.arg( leVille->text() );
			mPost.prepend( REQUESTER->freeGoBaseUrl() );
			REQUESTER->requestUrl( this, "readAnnuaire", mPost );
			pAnnuaire->setEnabled( false );
		}
		else
			UIMAIN->alert( QString::fromUtf8( "Vous devez entrer obligatoirement :\nun nom et soit un département, soit un code postal, soit une ville." ) );
	}
}

void UIPhone::readAnnuaire( QSettings* settings, bool error )
{
	if ( error )
	{
		UIMAIN->alert( "Une erreur est apparu a la récéption du resultat" );
		return;
	}
	
	pfgResultat->setVisible( true );
	
	// clear textedit
	teResultat->clear();
	// read messages
	int size = settings->beginReadArray( "ANNUAIRE" );
	if ( size > 0 )
	{
		teResultat->insertHtml( "<table align=\"center\" cellpadding=\"0\" border=\"0\" cellspacing=\"0\" width=\"100%\">" );
		for ( int i = 0; i < size; i++ )
		{
			settings->setArrayIndex( i );
			// fill infos
			teResultat->insertHtml( "<tr>" );
			teResultat->insertHtml( QString( "<td>%1</td>" ).arg( Qt::escape( QString::fromUtf8( settings->value( "NOM" ).toByteArray() ) ) ) );
			teResultat->insertHtml( QString( "<td>%1</td>" ).arg( Qt::escape( QString::fromUtf8( settings->value( "NUMERO" ).toByteArray() ) ) ) );
			teResultat->insertHtml( "</tr>" );
			teResultat->insertHtml( "<tr>" );
			teResultat->insertHtml( QString( "<td>%1</td>" ).arg( Qt::escape( QString::fromUtf8( settings->value( "ADRESSE" ).toByteArray() ) ) ) );
			teResultat->insertHtml( QString( "<td>%1</td>" ).arg( Qt::escape( QString::fromUtf8( settings->value( "VILLE" ).toByteArray() ) ) ) );
			teResultat->insertHtml( "</tr>" );
			teResultat->insertHtml( "<tr><hr /></tr>" );
		}
		settings->endArray();
		teResultat->insertHtml( "</table>" );
	}
	else
		teResultat->insertHtml( QString( "<center>%1</center>" ).arg( QString::fromUtf8( settings->value( "ERROR" ).toByteArray() ) ) );
	
	pAnnuaire->setEnabled( true );
}
